routes/web.php
<?php

Route::get('/', 'HomeController@index')->name('/');

Auth::routes();

//ACL==================================================================================================
Route::get('user/{user}/roles', 'UserController@roles')->name('user.roles')->middleware(['auth','role:Administrador']);
Route::put('user/{user}/roles', 'UserController@rolesSync')->name('user.roles')->middleware(['auth','role:Administrador']);

Route::resource('user', 'UserController');//->middleware(['auth','role:Administrador']);

Route::get('role/{role}/permissions', 'RoleController@permissions')->name('role.permissions')->middleware(['auth','role:Administrador']);
Route::put('role/{role}/permissions', 'RoleController@permissionsSync')->name('role.permissions')->middleware(['auth','role:Administrador']);
Route::resource('role', 'RoleController')->middleware(['auth','role:Administrador']);

Route::resource('permission', 'PermissionController')->middleware(['auth','role:Administrador']);
//======================================================================================================
Route::resource('produto', 'ProdutoController')->middleware(['auth','role:Administrador']);
Route::resource('categoria', 'CategoriaController')->middleware(['auth','role:Administrador']);

Route::get('/carrinho', 'CarrinhoController@index')->name('carrinho.index')->middleware('auth');
Route::get('/carrinho/adicionar', function() {
    return redirect()->route('/');
});
Route::post('/carrinho/adicionar', 'CarrinhoController@adicionar')->name('carrinho.adicionar')->middleware('auth');
Route::delete('/carrinho/remover', 'CarrinhoController@remover')->name('carrinho.remover')->middleware('auth');
Route::post('/carrinho/concluir', 'CarrinhoController@concluir')->name('carrinho.concluir')->middleware('auth');
Route::get('/carrinho/compras', 'CarrinhoController@compras')->name('carrinho.compras')->middleware('auth');
Route::post('/carrinho/cancelar', 'CarrinhoController@cancelar')->name('carrinho.cancelar')->middleware('auth');
Route::post('/carrinho/desconto', 'CarrinhoController@desconto')->name('carrinho.desconto')->middleware('auth');

/*ROTA DE TESTE FEATURE*/
Route::get('routeClosure', function() {
    return 'OK';
});

app/User.php
<?php

namespace App;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Spatie\Permission\Traits\HasRoles;

class User extends Authenticatable
{
    use Notifiable, HasRoles;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'cpf', 'telefone', 'email', 'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
}

app/Http/Controllers/UserController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\User;
use Spatie\Permission\Models\Role;
use Spatie\Permission\Models\Permission;

class UserController extends Controller
{
    private $users;
    private $user;
    private $rolesRequest;

    public function __construct(){
        $users = $this->users;
        $user = $this->user;
        $rolesRequest = $this->rolesRequest;
    }
   
    public function index()
    {
        $users = User::all();
        return view('users.index', compact('users'));
    }

    public function create()
    {
        return view('users.create');
    }

    public function store(Request $request)
    {
        $user = new user;
        $user->name = $request->name;
        $user->cpf = $request->cpf;
        $user->telefone = $request->telefone;
        $user->email = $request->email;
        $user->password = bcrypt($request->password);

        if(!$user->save()) {
            $notifications = array('message' => 'Erro ao efetuar o Cadastro!', 'alert-type' => 'danger');
            return back()->with($notifications);
        }else{
            $user->save();
            $notifications = array('message' => 'Cadastro efetuado com sucesso!', 'alert-type' => 'success');
            return back()->with($notifications);
        }

        return redirect()->route('user.index');

    }

    public function edit($id)
    {
        $user = User::find($id);
        return view('users.edit', compact('user'));
    }

    public function update(Request $request, $id)
    {
        $user = User::find($id);
        $user->name = $request->name;
         $user->cpf = $request->cpf;
        $user->telefone = $request->telefone;
        $user->email = $request->email;

        if(!empty($request->password))
        {
            $user->password = bcrypt($request->password);
        }

        if(!$user->update()) {
            $notifications = array('message' => 'Erro ao efetuar o Cadastro!', 'alert-type' => 'danger');
            return back()->with($notifications);
        }else{
            $user->update();
            $notifications = array('message' => 'Cadastro alterado com sucesso!', 'alert-type' => 'success');
            return back()->with($notifications);
        }

        return redirect()->route('user.index');

    }

    public function destroy($id)
    {
        $user = User::find($id);

        if(!$user->delete()) {
            $notifications = array('message' => 'Erro ao efetuar o Cadastro!', 'alert-type' => 'danger');
            return back()->with($notifications);
        }else{
            $user->delete();
            $notifications = array('message' => 'Cadastro deletado com sucesso!', 'alert-type' => 'success');
            return back()->with($notifications);
        }

        return redirect()->route('user.index');
    }

    public function roles($user) 
    {
        $user = User::where('id', $user)->first();
        $roles = Role::all();

        foreach($roles as $role)
        {
            //Verificando se o usuario tem a perfil
            if($user->hasRole($role->name))
            {
                $role->can = true; //criando novo atributo como flag para setar na view
            }else {
                $role->can = false;
            }
        }

        return view('users.roles', compact('user','roles'));
    }

    public function rolesSync(Request $request, $user) 
    {
        //Limpando o array
       $rolesRequest = $request->except(['_token','_method']);
       //Recuperando a chave para setar na busca dos modelos
       foreach($rolesRequest as $key => $value)
       {
           //Recuperando os medelos de objetos 
            $roles[] = Role::where('id',$key)->first();
       }
       //Sobrescrevendo a variavél que vem via parametro da função
       $user = User::where('id',$user)->first();

       if(!empty($roles))
       {
            //Método do Spatie que espera receber um array ou null
            $user->syncRoles($roles);
       } else {
            $user->syncRoles(null);
       }
       //Recebendo role->id do modelo e não da string passada por parametro.
       return redirect()->route('user.roles', ['user' => $user->id]);

    }
}

resources/views/users/create.blade.php
@extends('layouts.layout')

@section('content')
<div class="container" style="background-color: #e9e9e9; padding: 2%">
        <div class="row justify-content-center">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-header">
                        <div class="row">
                            <div class="col-md-10">REGISTRO DE USUÁRIO</div>
                            <div class="col-md-2"><a class="text-success" href="{{ route('user.index') }}">&leftarrow; Voltar para a listagem</a></div>
                        </div>
                    </div><br />
                    <div class="card-body">

                        <form action="{{ route('user.store') }}" method="post" class="mt-4" autocomplete="off">
                            @csrf

                            <div class="form-group">
                                <label for="name">Nome do Usuário</label> <span class="obrigatorio">*</span>
                                <input type="text" class="form-control" id="name" autofocus placeholder="Digite seu nome"
                                       name="name" value="{{ old('name') }}">
                                @if ($errors->has('name'))<span class="form-text help-block msg_validate">{{ $errors->first('name') }}</span>@endif
                            </div>
                            
                             <div class="form-group">
                                <label for="cpf">CPF</label> <span class="obrigatorio">*</span>
                                <input type="text" class="form-control" id="cpf"
                                       name="cpf" value="{{ old('cpf') }}">
                                @if ($errors->has('cpf'))<span class="form-text help-block msg_validate">{{ $errors->first('cpf') }}</span>@endif
                            </div>
                            
                             <div class="form-group">
                                <label for="telefone">Telefone</label> <span class="obrigatorio">*</span>
                                <input type="text" class="form-control" id="telefone"
                                       name="telefone" value="{{ old('telefone') }}">
                                @if ($errors->has('telefone'))<span class="form-text help-block msg_validate">{{ $errors->first('telefone') }}</span>@endif
                            </div>
                            
                            <div class="form-group">
                                <label for="email">E-mail</label> <span class="obrigatorio">*</span>
                                <input type="email" class="form-control" id="email" placeholder="Digite um e-mail"
                                       name="email" value="{{ old('email') }}">
                                @if ($errors->has('email'))<span class="form-text help-block msg_validate">{{ $errors->first('email') }}</span>@endif

                            </div>
                            <div class="form-group">
                                <label for="password">Senha</label> <span class="obrigatorio">*</span>
                                <input type="password" class="form-control" id="password" placeholder="Digite uma senha"
                                       name="password" value="{{ old('password') }}">
                                @if ($errors->has('password'))<span class="form-text help-block msg_validate">{{ $errors->first('password') }}</span>@endif

                            </div>

                            <button type="submit" class="btn btn-success"><i class="fas fa-save"></i> Cadastrar</button>
                            <a href="{{ route('user.index') }}" class="btn btn-info"><i class="fas fa-list"></i> Listar</a>
                            <a href="{{ route('/') }}" class="btn btn-danger"><i class="fas fa-ban"></i> Cancelar</a>
                        </form>
                    </div>

                </div>
            </div>
        </div>
    </div><br />
@endsection

resources/views/users/edit.blade.php
@extends('layouts.layout')

@section('content')
    <div class="container" style="background-color: #e9e9e9; padding: 2%">
        <div class="row justify-content-center">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-header">
                        <div class="row">
                            <div class="col-md-10">EDITAR USUÁRIO</div>
                            <div class="col-md-2"><a class="text-success" href="{{ route('user.index') }}">&leftarrow; Voltar para a listagem</a></div>
                        </div>
                    </div><br />

                    <div class="card-body">

                        @if($errors)
                            @foreach($errors->all() as $error)
                                <div class="alert alert-danger mt-4" role="alert">
                                    {{ $error }}
                                </div>
                            @endforeach
                        @endif

                        <form action="{{ route('user.update', ['user' => $user->id]) }}" method="post" class="mt-4" autocomplete="off">
                            @csrf
                            @method('PUT')

                            <div class="form-group">
                                <label for="name">Nome do Usuário</label>
                                <input type="text" class="form-control" id="name" placeholder="Insira o nome completo"
                                       name="name" value="{{ old('name') ?? $user->name }}">
                            </div>
                            
                             <div class="form-group">
                                <label for="cpf">CPF</label> <span class="obrigatorio">*</span>
                                <input type="text" class="form-control" id="cpf"
                                       name="cpf" value="{{ old('cpf') ?? $user->cpf}}">
                                @if ($errors->has('cpf'))<span class="form-text help-block msg_validate">{{ $errors->first('cpf') }}</span>@endif
                            </div>
                            
                             <div class="form-group">
                                <label for="telefone">Telefone</label> <span class="obrigatorio">*</span>
                                <input type="text" class="form-control" id="telefone"
                                       name="telefone" value="{{ old('telefone') ?? $user->telefone }}">
                                @if ($errors->has('telefone'))<span class="form-text help-block msg_validate">{{ $errors->first('telefone') }}</span>@endif
                            </div>
                            
                            <div class="form-group">
                                <label for="email">E-mail</label>
                                <input type="email" class="form-control" id="email" placeholder="Insira o e-mail do usuário"
                                       name="email" value="{{ old('email') ?? $user->email }}">
                            </div>
                            <div class="form-group">
                                <label for="password">Senha</label>
                                <input type="password" class="form-control" id="password" placeholder="digite uma nova senha"
                                       name="password" value="{{ old('password') }}">
                            </div>

                            <button type="submit" class="btn btn-success"><i class="fas fa-save"></i> Alterar</button>
                            <a href="{{ route('user.index') }}" class="btn btn-info"><i class="fas fa-list"></i> Listar</a>
                            <a href="{{ route('/') }}" class="btn btn-danger"><i class="fas fa-ban"></i> Cancelar</a>
                        </form>
                    </div>

                </div>
            </div>
        </div>
    </div><br />
@endsection

resources/views/users/index.blade.php
@extends('layouts.layout')

@section('content')
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-12">
                <div class="card">
                  <div class="card-header">
                        <div class="row">
                            <div class="col-md-10">LISTAGEM DE USUÁRIO</div>
                            <div class="col-md-2"><a class="text-success" href="{{ route('user.create') }}">&plus; Novo</a></div>
                        </div>
                    </div><br />
                    <div class="card-body">
                        @if (session('status'))
                            <div class="alert alert-success" role="alert">
                                {{ session('status') }}
                            </div>
                        @endif

                        @if($errors)
                            @foreach($errors->all() as $error)
                                <div class="alert alert-danger mt-4" role="alert">
                                    {{ $error }}
                                </div>
                            @endforeach
                        @endif

                        <table class="table table-striped mt-4">
                            <thead>
                            <tr>
                                <th>#</th>
                                <th>Usuários</th>
                                <th class="th-center">Editar</th>
                                <th class="th-center">Adicionar perfil</th>
                                <th class="th-center">Excluir</th>
                            </tr>
                            </thead>
                            <tbody>

                           @foreach($users as $user)
                           <tr>
                                    <td>{{ $user->id }}</td>
                                    <td>{{ $user->name }}</td>
                                    <td class="th-center"><a class="btn btn-link" href="{{ route('user.edit', ['user' => $user->id] ) }}">Editar</a></td>
                                    <td class="th-center"><a class="btn btn-link" href="{{ route('user.roles', ['user' => $user->id]) }}">Perfis</a></td>
                                    <td class="th-center">
                                        <form action="{{ route('user.destroy', ['user' => $user->id]) }}" method="post">
                                            @csrf
                                            @method('delete')
                                            <input class="btn btn-link" type="submit" value="Remover">
                                        </form>
                                    </td>
                                </tr>
                          @endforeach

                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div><br /><br />
@endsection

resources/views/users/roles.blade.php
@extends('layouts.layout')

@section('content')
    <div class="container" style="background-color: #e9e9e9; padding: 2%">
        <div class="row justify-content-center">
            <div class="col-md-12">
                <div class="card">
                  <div class="card-header">
                        <div class="row">
                            <div class="col-md-10">PERFIS</div>
                            <div class="col-md-2"><a class="text-success" href="{{ route('user.index') }}">&leftarrow; Voltar para a listagem</a></div>
                        </div>
                    </div><br />

                    <div class="card-body">

                        @if($errors)
                            @foreach($errors->all() as $error)
                                <div class="alert alert-danger mt-4" role="alert">
                                    {{ $error }}
                                </div>
                            @endforeach
                        @endif

                        <h2 class="mt-4">Perfis de: {{ $user->name }}</h2>

                        <form action="{{ route('user.roles', ['user' => $user->id]) }}" method="post" class="mt-4" autocomplete="off">
                            @csrf
                            @method('PUT')
                           @foreach($roles as $role)
                                <div class="custom-control custom-checkbox">
                                    <input type="checkbox" class="custom-control-input" id="{{ $role->id }}" name="{{ $role->id }}" {{ ($role->can == '1' ? 'checked':'') }} />
                                    <label class="custom-control-label" for="{{ $role->id }}">{{ $role->name }}</label>
                                </div>
                          @endforeach
                            <BR /><button type="submit" class="btn  btn-success">Sincronizar Perfis</button>
                        </form>
                    </div>

                </div>
            </div>
        </div>
    </div><br />
@endsection